Index: uspace/lib/libc/generic/string.c
===================================================================
--- uspace/lib/libc/generic/string.c	(revision 566987b0b136c4a5e4c99b9659c683aa5122e984)
+++ uspace/lib/libc/generic/string.c	(revision 0516fd716e8b774cf526e74c1239ba42ea1dcde0)
@@ -67,5 +67,6 @@
 		
 	for (j = 0; j < n % sizeof(unsigned long); j++)
-		((unsigned char *) (((unsigned long *) dst) + i))[j] = ((unsigned char *) (((unsigned long *) src) + i))[j];
+		((unsigned char *) (((unsigned long *) dst) + i))[j] =
+		    ((unsigned char *) (((unsigned long *) src) + i))[j];
 		
 	return (char *) src;
@@ -76,5 +77,6 @@
 	int i, j;
 
-	if (((long) dst & (sizeof(long) - 1)) || ((long) src & (sizeof(long) - 1)))
+	if (((long) dst & (sizeof(long) - 1)) ||
+	    ((long) src & (sizeof(long) - 1)))
  		return unaligned_memcpy(dst, src, n);
 
@@ -83,5 +85,6 @@
 		
 	for (j = 0; j < n % sizeof(unsigned long); j++)
-		((unsigned char *) (((unsigned long *) dst) + i))[j] = ((unsigned char *) (((unsigned long *) src) + i))[j];
+		((unsigned char *) (((unsigned long *) dst) + i))[j] =
+		    ((unsigned char *) (((unsigned long *) src) + i))[j];
 		
 	return (char *) src;
@@ -96,5 +99,6 @@
 
 	for (j = (n % sizeof(unsigned long)) - 1; j >= 0; j--)
-		((unsigned char *) ((unsigned long *) dst))[j] = ((unsigned char *) ((unsigned long *) src))[j];
+		((unsigned char *) ((unsigned long *) dst))[j] =
+		    ((unsigned char *) ((unsigned long *) src))[j];
 
 	for (i = n / sizeof(unsigned long) - 1; i >=0 ; i--)
@@ -106,10 +110,10 @@
 /** Compare two memory areas.
  *
- * @param s1	Pointer to the first area to compare.
- * @param s2	Pointer to the second area to compare.
- * @param len	Size of the first area in bytes. Both areas must have the same
- *		length.
- * @return	If len is 0, return zero. If the areas match, return zero.
- *		Otherwise return non-zero.
+ * @param s1		Pointer to the first area to compare.
+ * @param s2		Pointer to the second area to compare.
+ * @param len		Size of the first area in bytes. Both areas must have
+ * 			the same length.
+ * @return		If len is 0, return zero. If the areas match, return
+ * 			zero. Otherwise return non-zero.
  */
 int bcmp(const char *s1, const char *s2, size_t len)
@@ -121,6 +125,7 @@
 
 /** Count the number of characters in the string, not including terminating 0.
- * @param str string
- * @return number of characters in string.
+ *
+ * @param str		String.
+ * @return		Number of characters in string.
  */
 size_t strlen(const char *str) 
@@ -156,8 +161,10 @@
 }
 
-/** Return pointer to the first occurence of character c in string
- * @param str scanned string 
- * @param c searched character (taken as one byte)
- * @return pointer to the matched character or NULL if it is not found in given string.
+/** Return pointer to the first occurence of character c in string.
+ *
+ * @param str		Scanned string.
+ * @param c		Searched character (taken as one byte).
+ * @return		Pointer to the matched character or NULL if it is not
+ * 			found in given string.
  */
 char *strchr(const char *str, int c)
@@ -172,8 +179,10 @@
 }
 
-/** Return pointer to the last occurence of character c in string
- * @param str scanned string 
- * @param c searched character (taken as one byte)
- * @return pointer to the matched character or NULL if it is not found in given string.
+/** Return pointer to the last occurence of character c in string.
+ *
+ * @param str		Scanned string.
+ * @param c		Searched character (taken as one byte).
+ * @return		Pointer to the matched character or NULL if it is not
+ * 			found in given string.
  */
 char *strrchr(const char *str, int c)
@@ -192,11 +201,14 @@
 /** Convert string to a number. 
  * Core of strtol and strtoul functions.
- * @param nptr pointer to string
- * @param endptr if not NULL, function stores here pointer to the first invalid character
- * @param base zero or number between 2 and 36 inclusive
- * @param sgn its set to 1 if minus found
- * @return result of conversion.
- */
-static unsigned long _strtoul(const char *nptr, char **endptr, int base, char *sgn)
+ *
+ * @param nptr		Pointer to string.
+ * @param endptr	If not NULL, function stores here pointer to the first
+ * 			invalid character.
+ * @param base		Zero or number between 2 and 36 inclusive.
+ * @param sgn		It's set to 1 if minus found.
+ * @return		Result of conversion.
+ */
+static unsigned long
+_strtoul(const char *nptr, char **endptr, int base, char *sgn)
 {
 	unsigned char c;
@@ -220,5 +232,6 @@
 			return 0;
 		}
-		if ((base == 16) && (*str == '0') && ((str[1] == 'x') || (str[1] == 'X'))) {
+		if ((base == 16) && (*str == '0') && ((str[1] == 'x') ||
+		    (str[1] == 'X'))) {
 			str += 2;
 		}
@@ -239,5 +252,6 @@
 	while (*str) {
 		c = *str;
-		c = (c >= 'a' ? c - 'a' + 10 : (c >= 'A' ? c - 'A' + 10 : (c <= '9' ? c - '0' : 0xff)));
+		c = (c >= 'a' ? c - 'a' + 10 : (c >= 'A' ? c - 'A' + 10 :
+		    (c <= '9' ? c - '0' : 0xff)));
 		if (c > base) {
 			break;
@@ -258,5 +272,8 @@
 	
 	if (str == tmpptr) {
-		/* no number was found => first invalid character is the first character of the string */
+		/*
+		 * No number was found => first invalid character is the first
+		 * character of the string.
+		 */
 		/* FIXME: set errno to EINVAL */
 		str = nptr;
@@ -276,12 +293,15 @@
 
 /** Convert initial part of string to long int according to given base.
- * The number may begin with an arbitrary number of whitespaces followed by optional sign (`+' or `-').
- * If the base is 0 or 16, the prefix `0x' may be inserted and the number will be taken as hexadecimal one.
- * If the base is 0 and the number begin with a zero, number will be taken as octal one (as with base 8).
- * Otherwise the base 0 is taken as decimal.
- * @param nptr pointer to string
- * @param endptr if not NULL, function stores here pointer to the first invalid character
- * @param base zero or number between 2 and 36 inclusive
- * @return result of conversion.
+ * The number may begin with an arbitrary number of whitespaces followed by
+ * optional sign (`+' or `-'). If the base is 0 or 16, the prefix `0x' may be
+ * inserted and the number will be taken as hexadecimal one. If the base is 0
+ * and the number begin with a zero, number will be taken as octal one (as with
+ * base 8). Otherwise the base 0 is taken as decimal.
+ *
+ * @param nptr		Pointer to string.
+ * @param endptr	If not NULL, function stores here pointer to the first
+ * 			invalid character.
+ * @param base		Zero or number between 2 and 36 inclusive.
+ * @return		Result of conversion.
  */
 long int strtol(const char *nptr, char **endptr, int base)
@@ -306,12 +326,15 @@
 
 /** Convert initial part of string to unsigned long according to given base.
- * The number may begin with an arbitrary number of whitespaces followed by optional sign (`+' or `-').
- * If the base is 0 or 16, the prefix `0x' may be inserted and the number will be taken as hexadecimal one.
- * If the base is 0 and the number begin with a zero, number will be taken as octal one (as with base 8).
- * Otherwise the base 0 is taken as decimal.
- * @param nptr pointer to string
- * @param endptr if not NULL, function stores here pointer to the first invalid character
- * @param base zero or number between 2 and 36 inclusive
- * @return result of conversion.
+ * The number may begin with an arbitrary number of whitespaces followed by
+ * optional sign (`+' or `-'). If the base is 0 or 16, the prefix `0x' may be
+ * inserted and the number will be taken as hexadecimal one. If the base is 0
+ * and the number begin with a zero, number will be taken as octal one (as with
+ * base 8). Otherwise the base 0 is taken as decimal.
+ *
+ * @param nptr		Pointer to string.
+ * @param endptr	If not NULL, function stores here pointer to the first
+ * 			invalid character
+ * @param base		Zero or number between 2 and 36 inclusive.
+ * @return		Result of conversion.
  */
 unsigned long strtoul(const char *nptr, char **endptr, int base)