Index: arch/ia64/src/mm/tlb.c
===================================================================
--- arch/ia64/src/mm/tlb.c	(revision 9bda3af61b1e5c5556bef366d7bcfcbeb1e090a4)
+++ arch/ia64/src/mm/tlb.c	(revision 631ca4d04a2284ebd54da4b84fc569fab1e212a4)
@@ -443,7 +443,7 @@
  *
  * @param vector Interruption vector.
- * @param pstate Structure with saved interruption state.
- */
-void alternate_instruction_tlb_fault(__u64 vector, struct exception_regdump *pstate)
+ * @param istate Structure with saved interruption state.
+ */
+void alternate_instruction_tlb_fault(__u64 vector, istate_t *istate)
 {
 	region_register rr;
@@ -451,5 +451,5 @@
 	pte_t *t;
 	
-	va = pstate->cr_ifa;	/* faulting address */
+	va = istate->cr_ifa;	/* faulting address */
 	t = page_mapping_find(AS, va);
 	if (t) {
@@ -464,5 +464,5 @@
 		 */
 		if (!as_page_fault(va)) {
-			panic("%s: va=%P, rid=%d\n", __FUNCTION__, pstate->cr_ifa, rr.map.rid);
+			panic("%s: va=%P, rid=%d\n", __FUNCTION__, istate->cr_ifa, rr.map.rid);
 		}
 	}
@@ -472,7 +472,7 @@
  *
  * @param vector Interruption vector.
- * @param pstate Structure with saved interruption state.
- */
-void alternate_data_tlb_fault(__u64 vector, struct exception_regdump *pstate)
+ * @param istate Structure with saved interruption state.
+ */
+void alternate_data_tlb_fault(__u64 vector, istate_t *istate)
 {
 	region_register rr;
@@ -481,5 +481,5 @@
 	pte_t *t;
 	
-	va = pstate->cr_ifa;	/* faulting address */
+	va = istate->cr_ifa;	/* faulting address */
 	rr.word = rr_read(VA2VRN(va));
 	rid = rr.map.rid;
@@ -507,5 +507,5 @@
 		 */
 		if (!as_page_fault(va)) {
-			panic("%s: va=%P, rid=%d\n", __FUNCTION__, pstate->cr_ifa, rr.map.rid);
+			panic("%s: va=%P, rid=%d\n", __FUNCTION__, istate->cr_ifa, rr.map.rid);
 		}
 	}
@@ -517,7 +517,7 @@
  *
  * @param vector Interruption vector.
- * @param pstate Structure with saved interruption state.
- */
-void data_nested_tlb_fault(__u64 vector, struct exception_regdump *pstate)
+ * @param istate Structure with saved interruption state.
+ */
+void data_nested_tlb_fault(__u64 vector, istate_t *istate)
 {
 	panic("%s\n", __FUNCTION__);
@@ -527,11 +527,11 @@
  *
  * @param vector Interruption vector.
- * @param pstate Structure with saved interruption state.
- */
-void data_dirty_bit_fault(__u64 vector, struct exception_regdump *pstate)
+ * @param istate Structure with saved interruption state.
+ */
+void data_dirty_bit_fault(__u64 vector, istate_t *istate)
 {
 	pte_t *t;
 
-	t = page_mapping_find(AS, pstate->cr_ifa);
+	t = page_mapping_find(AS, istate->cr_ifa);
 	ASSERT(t && t->p);
 	if (t && t->p) {
@@ -548,11 +548,11 @@
  *
  * @param vector Interruption vector.
- * @param pstate Structure with saved interruption state.
- */
-void instruction_access_bit_fault(__u64 vector, struct exception_regdump *pstate)
+ * @param istate Structure with saved interruption state.
+ */
+void instruction_access_bit_fault(__u64 vector, istate_t *istate)
 {
 	pte_t *t;
 
-	t = page_mapping_find(AS, pstate->cr_ifa);
+	t = page_mapping_find(AS, istate->cr_ifa);
 	ASSERT(t && t->p);
 	if (t && t->p) {
@@ -569,11 +569,11 @@
  *
  * @param vector Interruption vector.
- * @param pstate Structure with saved interruption state.
- */
-void data_access_bit_fault(__u64 vector, struct exception_regdump *pstate)
+ * @param istate Structure with saved interruption state.
+ */
+void data_access_bit_fault(__u64 vector, istate_t *istate)
 {
 	pte_t *t;
 
-	t = page_mapping_find(AS, pstate->cr_ifa);
+	t = page_mapping_find(AS, istate->cr_ifa);
 	ASSERT(t && t->p);
 	if (t && t->p) {
@@ -590,7 +590,7 @@
  *
  * @param vector Interruption vector.
- * @param pstate Structure with saved interruption state.
- */
-void page_not_present(__u64 vector, struct exception_regdump *pstate)
+ * @param istate Structure with saved interruption state.
+ */
+void page_not_present(__u64 vector, istate_t *istate)
 {
 	region_register rr;
@@ -598,5 +598,5 @@
 	pte_t *t;
 	
-	va = pstate->cr_ifa;	/* faulting address */
+	va = istate->cr_ifa;	/* faulting address */
 	t = page_mapping_find(AS, va);
 	ASSERT(t);
@@ -613,6 +613,6 @@
 	} else {
 		if (!as_page_fault(va)) {
-			panic("%s: va=%P, rid=%d\n", __FUNCTION__, pstate->cr_ifa, rr.map.rid);
-		}
-	}
-}
+			panic("%s: va=%P, rid=%d\n", __FUNCTION__, istate->cr_ifa, rr.map.rid);
+		}
+	}
+}